function sfun_setcolorD(block)
% setzt die Hintergrundfarbe abhängig vom Eingangswert
  setup(block); 
end

%% -------------------------------------------------------------------
function setup(block)
  block.NumInputPorts  = 1;
  block.NumOutputPorts = 0;
  
  block.SetPreCompInpPortInfoToDynamic;  % Datentyp übernehmen
  block.SampleTimes = [-1 0];            % Samplezeit übernehmen
  
  block.RegBlockMethod('PostPropagationSetup', @DoPostPropSetup);
  block.RegBlockMethod('Start', @Start);
  block.RegBlockMethod('Update', @Update);
end

%% -------------------------------------------------------------------
function DoPostPropSetup(block)
  block.NumDworks = 1;

  block.Dwork(1).Name            = 'lastState'; 
  block.Dwork(1).Dimensions      = 1;
  block.Dwork(1).DatatypeID      = 0;
  block.Dwork(1).Complexity      = 'Real';
  block.Dwork(1).UsedAsDiscState = true;
end
    
%% -------------------------------------------------------------------
function Start(block)
  changeColor('off_color');
end

%% -------------------------------------------------------------------
function Update(block)
  input = block.InputPort(1).Data;
  state = block.Dwork(1).Data;

  % Icon nur bei Änderung malen, sonst Flackern!
  if (input > 0.5) && (state == 0)
    changeColor('on_color');
    state = 1;
  elseif (input <= 0.5) && (state == 1)
    changeColor('off_color');
    state = 0;
  end
  block.Dwork(1).Data = state;   % setzt Zustand auf neuen Wert
end

%% -------------------------------------------------------------------
function changeColor(colName)
% setzt die Icon-Farbe auf den entsprechenden Maskenwert
  sysname = gcs();
  col = get_param(sysname, colName);
  icon = sprintf('patch(sin(0:0.1:2*pi), cos(0:0.1:2*pi), %s)', col);
  set_param(sysname, 'MaskDisplay', icon);
end

    